# hc_h5.py : Hill Climbing, machine Hebern 5 rotors
# lampboard = identity
import sys
import string
import random
import math
import UN_ROT as UNROT
import getopt
import time
ALPHA = string.ascii_uppercase
N = 26

#==============================
def gen_key():
    ALPH=[]
    for i in range(N): 
        ALPH.append(None)
    CODE=""

    j = 0
    for i in range(1000):
        x = random.randrange(N)
        if not ALPH[x]:
            CODE = CODE + ALPHA[x] 
            ALPH[x] = 1
            j = j + 1
            if j == N:
                break

    return CODE
#================================================
def is_maj(car):
    if car in ALPHA:
        return True
    else:
        return False
# ===================================
def litfic( fic ):
        f = open(fic,"r")
        leTexte = f.readlines()
        texteConcat = ""
        f.close()
        for i in range(len(leTexte)):
                ch = leTexte[i]
                ch = ch.upper()
                for j in range(len(ch)):
                        if not is_maj(ch[j]):
                                continue
                        texteConcat = texteConcat + ch[j]
        return texteConcat
# ===================================
def ic(texte):
    lg = len(texte)
    if lg < 2:
        return 0.038
    freq = [0] * N
    for i in range(lg):
        idx = ALPHA.find(texte[i])
        freq[ idx ] += 1
    total = 0
    for i in range(N):
        if freq[i] >= 2:
            total += freq[ i ] * (freq[i] - 1)
    return total / (lg * (lg-1))
# ================================================
def fitness(crypto):
    ic_total = 0
    k = 0
    m = 0
    j = 0
    decal_initial = OFFSET
    while 1:
        debut = j 
        fin   = (j+N) - decal_initial 
        tranche = crypto[debut:fin]
        j = fin
        if decal_initial != 0: decal_initial = 0
        if j > len(crypto): break
        mono_substi = h.chiffre(tranche)
        ic_tranche = ic(mono_substi)
        if len(tranche) < N:
            ic_tranche = ic_tranche * (len(tranche)/N)
        ic_total += ic_tranche
        k += 1
    return ic_total / k

# ===================================
def fitness_IC(texte):
        f = []
        for i in range(N):
                f.append(0)
        N = len(texte)
        for i in range(N):
                indice = string.index(string.ascii_uppercase, texte[i])
                f[indice] = f[indice] + 1
        total = 0
        for i in range(N):
                if ( f[i] > 1):
                        total = total + f[i]*(f[i]-1)
        return total / float(N * (N-1))

#======================================
def new_cle( UNE_CLE ):
    tb = list( UNE_CLE )
    while 1 :
        x1 = random.randint( 0, 25 )
        x2 = random.randint( 0, 25 )
        if x1 == x2 : continue
        tempo = tb[ x1 ]
        tb[ x1 ] = tb[ x2 ]
        tb[ x2 ] = tempo

        return "".join( tb )

#======================================
def usage():
    print("usage:")
    print("  -h         Help")
    print("  -c crypto  The cryptogram")
    print("  -t tries   Number of tries, default: 15")
    print("  -o offset  Offset, 0 by default")
    print("notes:")
    print("1. The cryptogram must be 'stripped',")
    print("   i.e. without the action of the lampboard")
    print("2. Offset is relied to RAW (position of right ratchel wheel)")
    print("   ALPHA[ (13 + (N - offset)) % N ], N == 26")
#======================================
#>>>>>>>>>>>>>>>>>>>>>>>>><<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
#================== Debut Programme ===========================
try:
  opts, args = getopt.getopt(sys.argv[1:],
    "hc:t:o:", ["help", "crypto=", "tries=", "offset="])
except getopt.GetoptError as err:
  # print help information and exit:
  print(sys.argv[0],": ", str(err)) # option -a not recognized"
  usage()
  sys.exit(2)

CRYPTO = ""
random.seed()
MAX_SCORE = 0
MAX_Z = 10
OFFSET = 0

for o, a in opts:
  if o == "-v":
    verbose = True
  elif o in ("-h", "--help"):
    usage()
    sys.exit()
  elif o in ("-c", "--crypto"):
    CRYPTO = litfic(a)
  elif o in ("-t", "--tries"):
    MAX_Z = int(a)
  elif o in ("-o", "--offset"):
    OFFSET = int(a)
  else:
    assert False, "unhandled option"

if CRYPTO  == "":
  usage()
  sys.exit(1)

#>>>>>>>> on essaye 10 fois l'algo Hill Climbing
for i in range( MAX_Z ):
    #------- KEY_parent
    KEY_parent = gen_key()

    # - on dechiffre avec la cle courante
    h = UNROT.HEBERN( KEY_parent, 1)

    # - on calcule le fitness
    HIGH_SCORE = fitness( CRYPTO )    
    MAX_CLAIR = ""

    #------- on boucle tant qu'il y a amelioration
    j = 0
    while 1:
        # - on change legerement la cle
        KEY = new_cle( KEY_parent )
            
        # - on dechiffre avec la cle courante
        h = UNROT.HEBERN( KEY, 1)

        # - on calcule le fitness
        score = fitness( CRYPTO )

        # - on conserve le score si meilleur
        if score > HIGH_SCORE :
            KEY_parent = KEY        
            HIGH_SCORE = score
            j = 0
        else:
            j = j+1

        # - on sort si pas d'ameliroation
        if j > 1000:
            if HIGH_SCORE > MAX_SCORE:
                MAX_SCORE = HIGH_SCORE
                MAX_KEY = KEY_parent
            break
    # ------ affiche solution temporaire
    print(i, HIGH_SCORE, KEY_parent)

# ------ on affiche la solution
print()
print( "Key: ", MAX_KEY, " Score: ", MAX_SCORE)
h = UNROT.HEBERN(MAX_KEY, 1)
print(h.chiffre( CRYPTO ) )

